-- playerFeedBale
--
-- author: upsidedown
-- 

-- 3.11.2014
-- V2.0 with manual destroy of bales: 18.11.2014

print("--- loading BaleFeed-Mod V2.0 (by upsidedown) ---")

function FeedingTroughTipTrigger:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	
	FeedingTroughTipTrigger:superClass().triggerCallback(self,triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if true then
		if onEnter or onLeave then
			if otherId ~= 0 then
				local object = g_currentMission:getNodeObject(otherId);

				if object ~= nil then
					if object:isa(Bale) then
						
						local fillLevel = object:getFillLevel();
						local fillType = object:getFillType();
						
						if self.acceptedFillTypes[fillType] then
							if true or self.animalHusbandry:getHasSpaceForTipping(fillType) then							
								-- self:updateTrailerTipping(object, -fillLevel, fillType)
								-- object:delete();
								
								if object.BFtriggerList == nil then
									object.BFtriggerList = {};
								end;
								object.BFtriggerList[self] = onEnter;
								playerFeedBale.baleList[object] = true;
							
							else -- warning is full
								
							end;
						else --bales not accepted fillType warning here!
							
						end;					
					end;
				end;
			end;
		end;
	end;
	
end;

local oldFuncBaleDelete = Bale.delete;
function Bale.delete(bale)
	-- print("bale delete")
	playerFeedBale.baleList[bale] = nil;
	oldFuncBaleDelete(bale)
end;



local oldFTTTload = FeedingTroughTipTrigger.load;
function FeedingTroughTipTrigger:load(id, animalHusbandry)
	
	local res = oldFTTTload(self,id, animalHusbandry);
	if res then		
		setCollisionMask(self.triggerId,25165824); --set collision mask of trigger to accept bales AND trailers, shovels etc		
	else
		return false;
	end;
end;



playerFeedBale = {};
addModEventListener(playerFeedBale);

function playerFeedBale:loadMap(name)
	playerFeedBale.baleList = {};
	
end;

function playerFeedBale:deleteMap()
end


function playerFeedBale:mouseEvent(posX, posY, isDown, isUp, button)
end;

function playerFeedBale:keyEvent(unicode, sym, modifier, isDown)
end;


function playerFeedBale:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then
			if g_currentMission.controlPlayer and g_currentMission.player ~= nil then	
				if g_currentMission.controlledVehicle == nil then
					local nearestDistance = 2.0;
					local targetBale
					local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode);
					
					for bale,_ in pairs(playerFeedBale.baleList) do						
						local x,y,z = getWorldTranslation(bale.nodeId);
						local sx,sy,_ = project(x,y,z)
						if math.abs(sx-0.5) < 0.3 and math.abs(sy-0.5) < 0.3 then
							local dist = math.sqrt((x-px)^2+(z-pz)^2 + (y-py)^2)	
							if dist < nearestDistance then
								nearestDistance = dist;
								targetBale = bale;
							end;
						end;
					end;
					
					if targetBale ~= nil then
						local x,y,z = getWorldTranslation(targetBale.nodeId);
						local sx,sy,_ = project(x,y,z);
						
						local valid, trigger = playerFeedBale.baleHasValidTrigger(targetBale);
						
						if valid then

							targetBale.killCnt = Utils.getNoNil(targetBale.killCnt,0)
							
							local fillLevel = targetBale:getFillLevel();
							local fillType = targetBale:getFillType();
							local maxCnt = 15000; --straw makes a lot more work
							if fillType == Fillable.FILLTYPE_GRASS or fillType == Fillable.FILLTYPE_DRYGRASS or Fillable.FILLTYPE_GRASS_WINDROW or Fillable.FILLTYPE_DRYGRASS_WINDROW then
								maxCnt = 3000;
							end;

							if trigger.acceptedFillTypes[fillType] then
								if trigger.animalHusbandry:getHasSpaceForTipping(fillType) then  --
									-- renderText(sx,sy,0.03,"Einstreuen: "..string.format("%2.1f",targetBale.killCnt/maxCnt*100).."%")
									renderText(sx,sy,0.03,g_i18n:getText("einstreuen")..string.format(" %2.1f",targetBale.killCnt/maxCnt*100).."%")
									if InputBinding.isPressed(InputBinding.ACTIVATE_HANDTOOL) then
										targetBale.killCnt = targetBale.killCnt + dt;
									end;
									if targetBale.killCnt > maxCnt then
										if g_server ~= nil then
											trigger:updateTrailerTipping(targetBale, -fillLevel, fillType);
											targetBale:delete();
										else
											-- call MP event client2server only
											g_client:getServerConnection():sendEvent(Bale2TriggerEvent:new(targetBale, trigger));											
										end;
									end;
								end;
							end;							
						end;
					end;
				end;
			end;
		end;
	end;
end

function playerFeedBale.baleHasValidTrigger(bale)

	local valid = false;
	local triggerRes
	for trigger,isValid in pairs(bale.BFtriggerList) do
		if isValid then
			valid = isValid;
			triggerRes = trigger;
			break;
		end;	
	end;
	
	if not valid then
		playerFeedBale.baleList[bale] = nil; --remove from global list
	end;

	return valid, triggerRes
end;



function playerFeedBale:draw()   
end;



Bale2TriggerEvent = {};
Bale2TriggerEvent_mt = Class(Bale2TriggerEvent, Event);

InitEventClass(Bale2TriggerEvent, "Bale2TriggerEvent");

function Bale2TriggerEvent:emptyNew()
    local self = Event:new(Bale2TriggerEvent_mt);
    self.className="Bale2TriggerEvent";
    return self;
end;

function Bale2TriggerEvent:new(bale,trigger)
    local self = Bale2TriggerEvent:emptyNew()
    self.bale = bale;
	self.trigger = trigger;
	
	
    return self;
end;

function Bale2TriggerEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.bale));
    streamWriteInt32(streamId, networkGetObjectId(self.trigger));		
end;

function Bale2TriggerEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    local bale = networkGetObject(id);
	
	local id2 = streamReadInt32(streamId);
    local trigger = networkGetObject(id2);
	if bale ~= nil and trigger ~= nil then
		local fillLevel = bale:getFillLevel();
		local fillType = bale:getFillType();
		trigger:updateTrailerTipping(bale, -fillLevel, fillType);
		bale:delete();
	else
		-- print("already gone...")
	end;
end;
